package com.zskk.service;

import java.io.IOException;
import java.util.Date;
import java.util.UUID;
import com.jfinal.kit.PropKit;
import com.zskk.model.Exams;
import com.zskk.model.User;
import com.zskk.model.UserBind;

import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

public class UserService {

	private static final MediaType JSON_CODE = MediaType.get("application/json; charset=utf-8");

	private static final OkHttpClient OKHTTP_CLIENT = new OkHttpClient();


	/**
	 * 创建微信用户
	 * 
	 * @param openid
	 */
	public User createWxUserByGH(String openid, String gh) {
		User user = new User();
		user.setId(creatId());
		user.setWxOpenid(openid);
		switch (gh) {

		case "PACS_Online":
			user.setSource("中世康恺电子胶片平台");
			break;
			
		case "gh_728267809f40":
			user.setSource("测试微信");
			break;

		case "gh_c3ecc9e4d6e4":
			user.setSource("黑龙江省电子胶片平台");
			break;

		case "gh_bb923a0a951e":
			user.setSource("辽宁省电子胶片平台");
			break;

		default:
			user.setSource("测试微信");
			break;
		}
		user.setWxIcon("");
		user.setSubscribeStatus(2);
		user.setCreateAt(new Date());
		user.save();
		return user;
	}

	/**
	 * 创建微信用户
	 * 
	 * @param openid
	 */
	public User createWxUserByAppid(String openid, String appid) {
		User user = new User();
		user.setId(creatId());
		user.setWxOpenid(openid);
		switch (appid) {

		case "wx1f3dc2c37dce641b":
			user.setSource("中世康恺电子胶片平台");
			break;
			
		case "wx6a54bf0e98ecd2c7":
			user.setSource("测试微信");
			break;

		case "wxdeb75f5d7e5a2300":
			user.setSource("黑龙江省电子胶片平台");
			break;

		case "wx2f0834870403c54e":
			user.setSource("辽宁省电子胶片平台");
			break;

		default:
			user.setSource("测试微信");
			break;
		}
		user.setWxIcon("");
		user.setSubscribeStatus(2);
		user.setCreateAt(new Date());
		user.save();
		return user;
	}

	/**
	 * 创建微信用户
	 * 
	 * @param openid
	 */
	public UserBind bindUserReport(String uid, Exams exam) {
		UserBind userBind = new UserBind();
		userBind.setUserId(uid);
		userBind.setExamId(exam.getId());
		userBind.setPatientId(exam.getPatientId());
		userBind.setCreateAt(new Date());
		userBind.setBindWay(1);
		userBind.setStatus(1);
		userBind.save();
		return userBind;
	}

	/*
	 * 获取用户信息
	 */
	public void getUserInfo(String openid) {
//		ApiConfigKit.setThreadLocalApiConfig(getApiConfig());
//		String url = String.format(GET_USERINFO, AccessTokenApi.getAccessTokenStr(), openid);
//		String content = doGet(url);
//		JSONObject obj = JSON.parseObject(content);
//		if (obj.containsKey("errcode")) {
//		} else {
//			System.out.println(obj);
//			User account = User.dao.findFirst("select * from user where wx_openid=?",openid);
//			account.setWxIcon(obj.getString("headimgurl"));
//			account.setWxNickname(obj.getString("nickname"));
//			account.update();
//		}
	}

	/*
	 * 发送模板消息
	 */
	public void sendTemplateMsg(String openid, String url, String event, String userName) {
//		if (PropKit.getBoolean("devMode") == true) {
//			ApiConfigKit.setThreadLocalApiConfig(getApiConfig());
//			SimpleDateFormat sdf = new SimpleDateFormat("yyyy年MM月dd日  HH:mm:ss");
//			String time = sdf.format(new Date());
//			String json = TemplateData.New().setTouser(openid)
//					.setTemplate_id("eNs4B9rKo_0N-sF1NRmW6PESmTLm8zi_5Vl6ujeFngA").setTopcolor("#743A3A")
//					.setUrl(url)
//					.add("keyword1", time  , "#743A3A")
//					.add("keyword2", event , "#743A3A")
//					.add("keyword3", "用药了吗？用药后感觉怎么样？快来说说吧，我们不会将您的资料泄露，完成赢积分！", "#743A3A")
//					.build();
//			System.out.println(json);
//			ApiResult result = TemplateMsgApi.send(json);
//			System.out.println(result.getJson());
//		}else{
//			ApiConfigKit.setThreadLocalApiConfig(getApiConfig());
//			SimpleDateFormat sdf = new SimpleDateFormat("yyyy年MM月dd日  HH:mm:ss");
//			String time = sdf.format(new Date());
//			String json = TemplateData.New().setTouser(openid)
//					.setTemplate_id("U4cjem6T4heIpO6gS92XE2au9ZTr0mJcgutgEoDIpRI").setTopcolor("#743A3A")
//					.setUrl(url)
//					.add("first"   , event      , "#0DB0EB")
//					.add("keyword1", userName         , "")
//					.add("keyword2", ""         , "")
//					.add("keyword3", time       , "")
//					.add("remark"  , "请按时记录哦", "#BBBBBB")
//					.build();
//			System.out.println(json);
//			ApiResult result = TemplateMsgApi.send(json);
//			System.out.println(result.getJson());
//		}
	}

	private String creatId() {
		return UUID.randomUUID().toString().replace("-", "");
	}

	private String create_timestamp() {
		return Long.toString(System.currentTimeMillis() / 1000);
	}

	private String create_nonce_str() {
		return UUID.randomUUID().toString();
	}
	
	private static String run(String url) throws IOException {
		    Request request = new Request.Builder()
		        .url(url)
		        .build();

		    try (Response response = OKHTTP_CLIENT.newCall(request).execute()) {
		      return response.body().string();
		    }
		  }
	

	private static String post(String url, String json) throws IOException {
	    RequestBody body = RequestBody.create(json, JSON_CODE);
	    Request request = new Request.Builder()
	        .url(url)
	        .post(body)
	        .build();
	    try (Response response = OKHTTP_CLIENT.newCall(request).execute()) {
	      return response.body().string();
	    }
	  }  
	
	public static void main(String[] args) throws IOException {
//		        .url("http://wechat.pacsonline.cn/wx_patient/api/getQrcode?reportId=7e7a4cc7c93b4d2b")

	    String response = run("http://www.baidu.com");
	    System.out.println(response);
		
	}
}
